﻿// (c) Copyright Microsoft Corporation.
// This source is subject to the Microsoft Public License (Ms-PL).
// Please see http://go.microsoft.com/fwlink/?LinkID=131993 for details.
// All other rights reserved.

namespace Microsoft.Phone.Controls
{
    /// <summary>
    /// The rotate transition modes.
    /// </summary>
    public enum RotateTransitionMode
    {
        /// <summary>
        /// The rotate in 90 degrees clockwise transition mode.
        /// </summary>
        In90Clockwise,
        /// <summary>
        /// The rotate in 90 degrees counterclockwise transition mode.
        /// </summary>
        In90Counterclockwise,
        /// <summary>
        /// The rotate in 180 degrees clockwise transition mode.
        /// </summary>
        In180Clockwise,
        /// <summary>
        /// The rotate in 180 degrees counterclockwise transition mode.
        /// </summary>
        In180Counterclockwise,
        /// <summary>
        /// The rotate out 90 degrees clockwise transition mode.
        /// </summary>
        Out90Clockwise,
        /// <summary>
        /// The rotate out 90 degrees counterclockwise transition mode.
        /// </summary>
        Out90Counterclockwise,
        /// <summary>
        /// The rotate out 180 degrees clockwise transition mode.
        /// </summary>
        Out180Clockwise,
        /// <summary>
        /// The rotate out 180 degrees counterclockwise transition mode.
        /// </summary>
        Out180Counterclockwise
    };
}